# -*- coding: utf-8 -*-
#
# Cookbook Name:: moombot
# Recipe:: plugins
#
# Copyright 2015, Sliim
#

directory "#{node['moombot']['home']}/plugins" do
  owner node['moombot']['name']
  group node['moombot']['name']
  mode '0750'
end

if node['moombot']['plugins'].is_a? ::Chef::Node::ImmutableArray
  node.override['moombot']['plugin_list'] = node['moombot']['plugins']
  node['moombot']['plugins'].each do |name|
    moombot_plugin name
  end
elsif node['moombot']['plugins'].is_a? ::Chef::Node::ImmutableMash
  node.override['moombot']['plugin_list'] =
    node['moombot']['plugins'].map { |_k, v| v }.flatten
  node['moombot']['plugins'].each do |cookbook_name, plugins|
    plugins.each do |name|
      moombot_plugin name do
        cookbook cookbook_name
      end
    end
  end
else
  Chef::Log.warn('Cannot determine plugins list, '\
                 'attribute must be an Array or a Hash')
end

service node['moombot']['name'] do
  action :nothing
end
